using Learun.Util;
using System.Data;
using Learun.Application.TwoDevelopment.ZZDT_EC;
using System.Web.Mvc;
using System.Collections.Generic;

namespace Learun.Application.Web.Areas.ZZDT_EC.Controllers
{
    /// <summary>
    /// 版 本 PIT-ADMS V7.0.3 敏捷开发框架
    /// Copyright (c) 2013-2018 Hexagon PPM
    /// 创 建：超级管理员
    /// 日 期：2022-03-03 16:57
    /// 描 述：元件库目录表
    /// </summary>
    public class ec_library_catalogueController : MvcControllerBase
    {
        private ec_library_catalogueIBLL ec_library_catalogueIBLL = new ec_library_catalogueBLL();

        #region 视图功能

        /// <summary>
        /// 主页面
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }
        /// <summary>
        /// 表单页
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Form()
        {
            return View();
        }
        #endregion

        #region 获取数据

        /// <summary>
        /// 获取页面显示列表数据
        /// <summary>
        /// <param name="queryJson">查询参数</param>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetList(string queryJson)
        {
            var data = ec_library_catalogueIBLL.GetList(queryJson);
            return Success(data);
        }
        /// <summary>
        /// 获取表单数据
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetFormData(string keyValue, string ProjectId)
        {
            var ec_library_catalogueData = ec_library_catalogueIBLL.GetEntity(keyValue, ProjectId);
            var jsonData = new
            {
                ec_library_catalogue = ec_library_catalogueData,
            };
            return Success(jsonData);
        }
        /// <summary>
        /// 获取元件库目录树形数据
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetTreeData(string ProjectId, string LibraryCatalogueID)
        {
            string queryJson = "{\"ProjectId\":\"" + ProjectId + "\",\"CurLibraryCatalogueID\":\"" + LibraryCatalogueID + "\"}";
            var list = ec_library_catalogueIBLL.GetList(queryJson);
            List<TreeModel> treeList = new List<TreeModel>();
            foreach (var item in list)
            {
                TreeModel node = new TreeModel();
                node.id = item.LibraryCatalogueID;
                node.text = item.LibraryCatalogueName;
                node.value = item.LibraryCatalogueID;
                node.showcheck = false;
                node.checkstate = 0;
                node.isexpand = false;
                node.parentId = item.UpLibraryCatalogueID;
                node.NodeExtData = item;
                treeList.Add(node);
            }
            return Success(treeList.ToTree());
        }
        #endregion

        #region 提交数据

        /// <summary>
        /// 删除实体数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [AjaxOnly]
        public ActionResult DeleteForm(string keyValue, string ProjectId)
        {
            ec_library_catalogueIBLL.DeleteEntity(keyValue, ProjectId);
            return Success("删除成功！");
        }
        /// <summary>
        /// 保存实体数据（新增、修改）
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOnly]
        public ActionResult SaveForm(string keyValue, string strEntity, string ProjectId)
        {
            ec_library_catalogueEntity entity = strEntity.ToObject<ec_library_catalogueEntity>();
            ec_library_catalogueIBLL.SaveEntity(keyValue, entity, ProjectId);
            if (string.IsNullOrEmpty(keyValue))
            {
            }
            return Success("保存成功！");
        }
        #endregion

    }
}
